from aui import App
import tkinter as tk


class _App(tk.Frame):
    """Actual Tk application class"""

    def __init__(self, master=None):
        """
        Keyword arguments:
        master -- parent of the element (default: None)
        """
        super().__init__(master)
        self.pack(fill=tk.constants.BOTH, expand=1)


class TkApp(App):

    def __init__(self, ui, title=None):
        """
        Keyword arguments:
        ui      -- an object representing User Interface (widgets, containers)
        title   -- window title
                   | str
        """
        self.app = _App()
        self.__parse_ui(ui)
        self.__setup_config(title)
        self.app.bind_class('Text', '<Control-a>', lambda e: e.widget.tag_add("sel", "1.0", "end"))

    def __setup_config(self, title):
        """
        Sets up the application config (window title).

        Keyword arguments:
        config  -- dict with application configuration
        """
        self.app.master.title(title or App.DEFAULT_TITLE)

    def __parse_ui(self, root):
        """Creates UI based on the root UI object"""
        root.create(self.app)

    def run(self):
        """Runs application"""
        self.app.mainloop()
